package com.jforeach.mazegame;

import com.jforeach.mazegame.R;

import android.R.string;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Point;
import android.graphics.Typeface;
import android.util.Log;
import android.view.Display;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.MotionEvent;
import android.view.View;
import android.widget.LinearLayout;
import android.widget.TextView;

public class GameView extends View {
	
	//width and height of the whole maze and width of lines which
	//make the walls
	private int width, height, lineWidth;
	//size of the maze i.e. number of cells in it
	private int mazeSizeX, mazeSizeY;
	//width and height of cells in the maze
	float cellWidth, cellHeight;
	//the following store result of cellWidth+lineWidth 
	//and cellHeight+lineWidth respectively 
	float totalCellWidth, totalCellHeight;
	//the finishing point of the maze
	private int mazeFinishX, mazeFinishY;
	private Maze maze;
	private Activity context;
	private Paint line, red, background;
	
	int currentX = 20, currentY = 150;
	int ballVelX = 5, ballVelY = 5;
	int i = 1;
	int screenWidth = 450;
	int lineStartX = 100, lineEndX = 300;
	int compLine1StartX = 100, compLine1EndX = 200;
	int compLine2StartX = 300, compLine2EndX = 400;
	int playerPoints = 0, computerPoints = 0;
	
		
	//Janne!
	
	@Override
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		// TODO Auto-generated method stub
		//event.getAction();
		if ((event.getAction() == KeyEvent.ACTION_DOWN) && (keyCode == KeyEvent.KEYCODE_DPAD_LEFT)){
			if(lineStartX >= 5){
				lineStartX = lineStartX - 5; lineEndX = lineEndX - 5;
			}
		}
		if ((event.getAction() == KeyEvent.ACTION_DOWN) && (keyCode == KeyEvent.KEYCODE_DPAD_RIGHT)){
			if(lineEndX <= 475){
				lineStartX = lineStartX + 5; lineEndX = lineEndX + 5;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	
	
	
	
	
	public GameView(Context context, Maze maze) {
		super(context);
		this.context = (Activity)context;
		this.maze = maze;
		mazeFinishX = maze.getFinalX();
		mazeFinishY = maze.getFinalY();
		mazeSizeX = maze.getMazeWidth();
		mazeSizeY = maze.getMazeHeight();
		line = new Paint();
		line.setColor(getResources().getColor(R.color.line));
		red = new Paint();
		red.setColor(getResources().getColor(R.color.position));
		background = new Paint();
		background.setColor(getResources().getColor(R.color.game_bg));
		setFocusable(true);
		this.setFocusableInTouchMode(true);
		
		/*
		 * 
		 * Blah
		 * 
		 * Display display = getWindowToken().getDefaultDisplay();
		Point size = new Point();
		display.getSize(size);
		int screenWidth = size.x;
		int screenheight = size.y;*/
		//currentX = currentX+1;
	}
	protected void onSizeChanged(int w, int h, int oldw, int oldh) {
		width = (w < h)?w:h;
		height = width;         //for now square mazes
		lineWidth = 5;          //for now 1 pixel wide walls
		cellWidth = (width - ((float)mazeSizeX*lineWidth)) / mazeSizeX;
		totalCellWidth = cellWidth+lineWidth;
		cellHeight = (height - ((float)mazeSizeY*lineWidth)) / mazeSizeY;
		totalCellHeight = cellHeight+lineWidth;
		//red.setTextSize(cellHeight*0.75f);
		super.onSizeChanged(w, h, oldw, oldh);
	}
	
	
	
	

   
	
	protected void onDraw(Canvas canvas) {
		//fill in the background
		canvas.drawRect(0, 0, width, height, background);
		
		
		//computer paddle
	
		canvas.drawLine(compLine1StartX, 20, compLine1EndX, 20, line);
		canvas.drawLine(compLine2StartX, 20, compLine2EndX, 20, line);
		
		//bottom paddle
		
		canvas.drawLine(lineStartX, 450, lineEndX, 450, line);
		
		//ball movement control
		
		currentX = currentX + ballVelX;
		currentY = currentY + ballVelY;
		
		if(currentX <= 0){
			ballVelX = ballVelX *-1;
		}
		
		if(currentY <= 0 | currentY == 20 & ((currentX > compLine1StartX & currentX < compLine1EndX) | (currentX > compLine2StartX & currentX < compLine2EndX))){
			if(ballVelY<0){
				ballVelY = ballVelY *-1;
			}
			//yay! point!
			if(currentY <= 0){
				playerPoints += 1;
			}
		}
		
		if(currentX >= 480){
			ballVelX = ballVelX *-1;
		}
		
		if(currentY >= 480 | (currentY == 450 & (currentX > lineStartX & currentX < lineEndX))){
			if(ballVelY>0){
				ballVelY = ballVelY *-1;
			}
			if(currentY >= 480){
				computerPoints += 1;
			}
		}
		
		//int currentX = maze.getCurrentX(),currentY = maze.getCurrentY();
		//draw the ball
		//canvas.drawCircle(200, 150, 10, red);
		canvas.drawCircle(currentX,   //x of center
				  currentY,  //y of center
				  5,                           //radius
				  red);
	
		// print points!!
		
		//public static void main(String[] args) {
			
		//}
		//images
		
			canvas.drawBitmap(BitmapFactory.decodeResource(getResources(), R.drawable.star), 60, 250, null);
		

			
			
			

			
			
			
			/*###############
			 * 
			 * Point system:
			 * 
			 ###############*/
			
			canvas.drawText("Computer",
					10,	185, red);
			canvas.drawText("Player",
					10,	235, red);
			
			String cPoints = Integer.toString(computerPoints);
			
			
			canvas.drawText(cPoints,
					10,	200, red);
			
			String pPoints = Integer.toString(playerPoints);
			
			//playerPoints = playerPoints + "";
			canvas.drawText(pPoints,
					10,	250, red);
			
					
			
			// moving the paddle
		

			invalidate();
			
			
			
			
			 
			 
			
			/*if(i==1){
			currentX = currentX+2;
			currentY = currentY+1;
			i=1;
			}
			
			if(currentX > 0& currentX >= screenWidth | i==2){
				currentX = currentX*-1;
			
				currentY = currentY+1;
				i=2;
		
			}*/

//if(currentX > screenWidth || currentX < 0)
  //   		ballVelocityX *= -1;
	}
	
}
